#ifndef Aufzeichnung_H
#define Aufzeichnung_H

#include <AufzeichnungV.h>
#include "Bestenliste/VideoBestenliste.h"
#include "Chat/VideoChat.h"
#include "Ende/VideoEnde.h"
#include "Nachricht/VideoNachricht.h"
#include "Spieler/VideoSpieler.h"
#include "Steuerung/VideoSteuerung.h"

class Aufzeichnung : public AufzeichnungV
{
private:
	Schrift *schrift;
	Bildschirm *screen;
	SpielNachricht *nachrichten;
	VideoBestenliste *bestenliste;
	VideoChat *chat;
	VideoSteuerung *steuerung;
	VideoKamera *kam;
	VideoKarte *map;
	VideoEnde *ende;
	RCArray< VideoSpieler > *spieler;
	VideoMSG *nMsg;
	bool nMsgVorwrts;
	Array< double > *rSpielZeit;
	double pauseZeit;
	double spielZeit;
	double time;
	bool spielPause;
	int spielerAnzahl;
	int teamAnzahl;
	int kamSpielerNummer;
	int mx;
	int my;
	bool geladen;
	int ref;

public:
	// Konstruktor
	Aufzeichnung();
	// Destruktor
	~Aufzeichnung();
	// nicht constant
	void setSchrift( Schrift *schrift ) override;
	void setBildschirm( Bildschirm *screen ) override;
	bool ladeSpiel( int id ) override;
	void doMausEreignis( MausEreignis &me ) override;
	void doTastaturEreignis( TastaturEreignis &te ) override;
	bool spielTick( double spielZeit );
	bool tick( double tickVal ) override;
	void render( Bild &zRObj ) override;
	// constant
	bool hatVerlassen( bool jetzt ) const override;
	// Reference Counting
	AufzeichnungV *getThis() override;
	AufzeichnungV *release() override;
};

#endif