#ifndef VideoKamera_H
#define VideoKamera_H

#include "../Karte/VideoKarte.h"

class VideoKamera
{
private:
	Punkt pos;
	Punkt gr;
	int runde;
	Array< Punkt > *rundePos;
	Array< Punkt > *rundeGr;
	Punkt rGr;
	LRahmen *rahmen;
	int ref;

public:
	// Konstruktor
	VideoKamera();
	// Destruktor
	~VideoKamera();
	// nicht constant
	void setPosition( int x, int y );
	void addPosition( int x, int y, VideoKarte *zMap );
	void setSize( int br, int h );
	void render( Bild &zRObj );
	void nextRunde( bool vorwrts );
	// constant
	int getLinks() const;
	int getOben() const;
	int getRechts() const;
	int getUnten() const;
	bool istSichtbar( int x, int y ) const;
	bool istMausIn( int x, int y ) const;
	int getRX( int mapX ) const;
	int getRY( int mapY ) const;
	int getX() const;
	int getY() const;
	// Reference Counting
	VideoKamera *release();
	VideoKamera *getThis();
};

#endif