#ifndef VideoSteuerung_H
#define VideoSteuerung_H

#include <Knopf.h>

using namespace Framework;

class VideoSteuerung
{
private:
	Punkt pos;
	Knopf *verlassen;
	Knopf *langsamer;
	Knopf *stop;
	Knopf *schneller;
	TextFeld *zeit;
	double spielZeit;
	int speed;
	bool vorwrts;
	bool zeitlupe;
	bool beendet;
	bool bJetzt;
	int ref;

public:
	// Konstruktor
	VideoSteuerung( Schrift *zSchrift, Bildschirm *zScreen );
	// Destruktor
	~VideoSteuerung();
	// Nicht constant
	void doMausEreignis( MausEreignis &me );
	bool tick( double zeit );
	void render( Bild &zRObj );
	void pause( bool ende );
	bool istBeendet( bool jetzt );
	// constant
	int getSpeed() const;
	bool istVorwrts() const;
	bool istZeitlupe() const;
	// Reference Counting
	VideoSteuerung *getThis();
	VideoSteuerung *release();
};

#endif